; This is the object driving source

		; Build the clipping code

Show_Objects:	mov ax,cs:Screen_X	; LHS
		sub ax,24		;
		jns SO_1		; < 0 ?

		mov ax,0		; Clip to 0

SO_1:		mov cs:SO_smc_1,ax	; Save it

		add ax,View_Width+48	; RHS

		mov cs:SO_smc_2,ax	; Save it

		mov ax,cs:Screen_Y	; TOP
		sub ax,24		;
		jns SO_2		; < 0 ?

		mov ax,0		; Clip to 0

SO_2:		mov cs:SO_smc_3,ax	; Save it

		add ax,View_Height+48	; BOTT

		mov cs:SO_smc_4,ax	; Save it

		jmp s SO_Start		; Flush the cache

	; Now drive down the list

SO_Start:	mov di,o Object_List	; Point at the objects

		; Now, move down this list showing the balls

SO_Lp:		mov bx,cs:[di]		; Get the X
		mov dx,cs:2[di]		; Y

		mov ax,bx		; End ?
		or ax,dx		;
		jz SO_X			; Yes, skip

		; Now, can we see this ?

		cmp bx,1234h		; LHS ?
SO_smc_1	equ this word - 2	;

		jnc SO_3		; Perhaps, skip

		; No, skip

SO_Next:	lea di,6[di]		; Skip

		jmp s SO_Lp		; Loop

	; To the right

SO_3:		cmp bx,1234h		; RHS ?
SO_smc_2	equ this word - 2 	;

		jnc SO_Next		; Off screen, skip

		; Compare Y

		cmp dx,1234h		; TOP
SO_smc_3	equ this word - 2	;

		jc SO_Next		; Off screen, skip

		cmp dx,1234h		; BOTT
SO_smc_4	equ this word - 2	;

		jnc SO_Next		; Off screen, skip

		; Right, we can see this object

		mov ax,cs:4[di]		; Get the type of object

		cmp ax,1		; Ball ?
		jne SO_Next		; No, ignore it

		; This is a ball, on screen, has the player hit it ?

		mov ax,cs:Player_X	; Compare the 'x's
		sub ax,bx		; Get the diff
		jns SO_B_1		;

		neg ax			; Make it +ve

SO_B_1:		cmp ax,8		; Close ?
		ja SO_ShowBall		; No, skip

		; Check the Y

		mov ax,cs:Player_Y	; Compare the 'y's
		sub ax,13		; Middle of the player

		sub ax,dx		; Get the diff
		jns SO_B_2		;

		neg ax			; Make it +ve

SO_B_2:		cmp ax,17		; Close ?
		ja SO_ShowBall		; No, skip

		; We are in contact with this ball, are we falling ?

;		mov ax,cs:Player_dY	; Get the dY
;		cmp ax,0
;		js SO_ShowBall
;		cmp ax,300h		; Big enough
;		jb SO_ShowBall		; No, skip
		
		; We have hit this ball, collect it

		mov w cs:4[di],0	; Kill it

		; Collect the ball

		call Collect_Ball	; Collect it

		jmp s SO_Next		; Done, exit

		; Right, show this ball

SO_ShowBall:	push di			; Save

;		mov al,b cs:Frame_No	; Calc the sprite
;		add al,bl		; Randomize
;		add al,dl		;

;		shr al,1
;		and ax,7
;		add al,iRot

;		mov ax,iLink

;		push bx
;		push dx
;		call Draw_Sprite
;		pop dx
;		pop bx

		call Draw_Ball		; Show it
		pop di			; Restore

		; Done, loop

		jmp s SO_Next		; Loop

	; Exit

SO_X:		ret			; Done

; Collect a ball

Collect_Ball:	mov ax,1		; One point
		call Add_Score		;

		; Create a fizzle here

		mov cx,o Move_Fizzle	; This one
		mov ax,112		; Life
		call Create_Fizzle	; Add a sparkle

		; Step the fire-rate

		call Imp_Fire_Rate	; Step it

		; Done, exit

		call ns_Collect		; Collect a ball

		ret			; Done		

; Vars

